/*
 * Created on 2005/05/03
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package net.fladdict.oscillator;

/**
 * @author Taka
 *
 * Based on Compsite pattern of GOF
 * 
 */
public class OscComposite extends OscAmplifier{
	protected Oscillator[] childOscillators;
	
	
	public OscComposite(Oscillator[] osc_ar){
		amplitudeOsc = new OscConstant(1);
		ampOffsetOsc = new OscConstant(0);
		
		childOscillators = osc_ar;
		calcValue();
	}
	
	
	
	public void update(){
		super.update();	//update amplitude
		calcValue();
	}
	
	
	
	protected void calcValue(){
		value = 0;
		
		int imax = childOscillators.length;
		for(int i=0; i<imax; i++){
			Oscillator osc = childOscillators[i];
			osc.update();
			value += osc.getValue();
		}
	}
	
	
	
	public void addOscillator(Oscillator osc){
		int oscLeng = childOscillators.length;
		Oscillator[] osc_ar = new Oscillator[oscLeng+1];
		for(int i=0; i<oscLeng; i++){
			osc_ar[i] = childOscillators[i];
		}
		osc_ar[oscLeng] = osc;
		childOscillators = osc_ar;
	}
	
	
	
	public Object clone(){
		Oscillator[] childOsc = childOscillators;
		int leng = childOscillators.length;
		for(int i=0; i<leng; i++){
			Oscillator osc = (Oscillator)childOscillators[i].clone();
			childOsc[i] = osc;
		}
		return new OscComposite(childOsc);
	}
	
	
	
	public void setChildOscillators(Oscillator[] osc_ar){
		childOscillators = osc_ar;
	}
	
	
	
	public Oscillator[] getChildOscillators(){
		return childOscillators;
	}
	
	
	
	public String toString(){
		return "OscComposite";
	}
}
