/*
 * Created on 2005/05/03
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package net.fladdict.oscillator;

/**
 * @author Taka
 * super class for all wave class(except noise);
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
public abstract class OscWave extends OscAmplifier{
	protected Oscillator periodOsc;
	protected Oscillator perOffsetOsc;
	protected float frequency;	//caluculated automatically
	protected float counter;	//increment counter
	
	
	public OscWave(float amp, float prd, float aoff, float poff){
		init(amp, prd, aoff, poff);
	}
	
	public OscWave(float amp, float prd){
		init(amp, prd, 0, 0);
	}
	
	public OscWave(float amp, float prd, float aoff){
		init(amp, prd, aoff, 0);
	}
	
	protected void init(float amp, float prd, float aoff, float poff){
		amplitudeOsc = new OscConstant(amp);
		periodOsc 	 = new OscConstant(prd);
		ampOffsetOsc = new OscConstant(aoff);
		perOffsetOsc = new OscConstant(poff);
		frequency = 1 / periodOsc.getValue();
		calcValue();
	}
	
	
	public void update(){
		super.update();	// update amplitude oscilator
		periodOsc.update();
		perOffsetOsc.update();
		
		calcValue();	//SHOULD BE IMPLEMENTED IN SUBCLASS
		addCounter();
	}
	
	protected void addCounter(){
		counter ++;
		if(counter > periodOsc.getValue())counter -= periodOsc.getValue();
		if(counter < -periodOsc.getValue())counter += periodOsc.getValue();
	}
	
	
	
	/*
	 * --------------------------------------------------
	 * 	GETTER / SETTER
	 * --------------------------------------------------
	 */
	
	
	public float getPeriod(){
		return periodOsc.getValue();
	}
	
	public void setPeriod(float prd){
		setPeriod(new OscConstant(prd));
	}
	
	public void setPeriod(int prd){
		setPeriod(new OscConstant(prd));
	}
	
	public void setPeriod(Oscillator osc){
		periodOsc = osc;
		frequency = 1 / periodOsc.getValue();
	}
	
	public Oscillator getPeriodOsc(){
		return periodOsc;
	}
	
	
	/*
	 *  (non-Javadoc)
	 * @see net.fladdict.oscillator.Oscillator#getFrequency()
	 */
	
	public float getPerOffset(){
		return perOffsetOsc.getValue();
	}
	
	public void setPerOffset(float off){
		perOffsetOsc = new OscConstant(off);
	}
	
	public void setPerOffset(int off){
		perOffsetOsc = new OscConstant(off);
	}
	
	public void setPerOffset(Oscillator osc){
		perOffsetOsc = osc;
	}
	
	public Oscillator getPerOffsetOsc(){
		return perOffsetOsc;
	}
	
	
	/*
	 *  (non-Javadoc)
	 * @see net.fladdict.oscillator.Oscillator#getFrequency()
	 */
	
	public float getFrequency(){
		return frequency;
	}
	
	public float getCounter(){
		return counter;
	}
}
