/*
 * Created on 2005/05/02
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package net.fladdict.oscillator;

/**
 * @author Taka
 * @varsion 0.1
 * 
 * CREATIVE COMMONS
 * Attribution-ShareAlike 2.1 Japan
 * http://creativecommons.org/licenses/by-sa/2.1/jp/deed.en
 *
 * Base class for all net.fladdict.ocillator.*
 * This is based on template & composite pattern of GOF
 *
 */
public abstract class Oscillator implements Cloneable{
	protected float value;

	
	public void update(){
		calcValue();
	}
	
	protected void calcValue(){
		/*
		 * template method
		 * here should be implemented in the subclass
		 */
		throw new Error(".calcValue should be implemented in subclass");
	}
	
	/**
	 * clne is not implemented yet.
	 */
	public Object clone(){
		 try {
            return (super.clone());
        } catch (CloneNotSupportedException e) {
            throw (new InternalError(e.getMessage()));
        }
	}

	
	/*
	 * --------------------------------------------------
	 * 	GETTER / SETTER
	 * --------------------------------------------------
	 */
	
	public void setAmplitude(float amp){}
	
	public void setAmplitude(int amp){}
	
	public void setAmplitude(Oscillator osc){}

	public float getAmplitude(){
		return 0;
	}
	
	public Oscillator getAmplitudeOsc(){
		return new OscConstant(0);
	}

	
	public void setPeriod(float prd){}
	
	public void setPeriod(int prd){}
	
	public void setPeriod(Oscillator osc){}
	
	public float getPeriod(){
		return 0;
	}
	
	public Oscillator getPeriodOsc(){
		return new OscConstant(0);
	}

	
	public void setAmpOffset(float off){}
	
	public void setAmpOffset(int off){}
	
	public void setAmpOffset(Oscillator osc){}
	
	public float getAmpOffset(){
		return 0;
	}
	
	public Oscillator getAmpOffsetOsc(){
		return new OscConstant(0);
	}
	
	
	public void setPerOffset(float off){}
	
	public void setPerOffset(int off){}
	
	public void setPerOffset(Oscillator osc){}
	
	public float getPerOffset(){
		return 0;
	}
	
	public Oscillator getPerOffsetOsc(){
		return new OscConstant(0);
	}
	
	
	public float getFrequency(){
		return 0;
	}
	
	
	public float getCounter(){
		return 0;
	}
	
	
	public float getValue(){
		return value;
	}
	
	
	public String toString(){
		throw new Error("Oscillator");
	}
	
	/**
	 * -------------------------------------------------------
	 * DUMMY METHOD for OscComponent
	 * Those function must be implemented in the subclass
	 * of OscComposite
	 * -------------------------------------------------------
	 */
	
	public void addOscillator(Oscillator osc){
		throw new Error("this class doesnot support .addOscillators");
	}
	
	public void setChildOscillators(Oscillator[] osc_ar){
		throw new Error("this class doesnot support .setChildOscillators");
	}
	
	public Oscillator[] getChildOscillators(){
		throw new Error("this class doesnot support .getChildOscillators");
	}
}
